/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package web;

import ejb.NewsEntity;
import ejb.NewsEntityFacade;
import ejb.Users;
import ejb.UsersFacade;
import java.io.IOException;
import java.io.PrintWriter;
import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author sinem
 */
@WebServlet(name="SaveChanges", urlPatterns={"/SaveChanges"})
public class SaveChanges extends HttpServlet {
    @EJB
    private UsersFacade usersFacade;
    @EJB
    private NewsEntityFacade newsEntityFacade;
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

        response.setContentType("text/html;charset=UTF-8");
        Long id=Long.parseLong(request.getQueryString().substring(3));
        HttpSession session=request.getSession(true);

        NewsEntity old=newsEntityFacade.find(id);
        String Location=request.getParameter("localInfo").toString();
        if(Location.equals("MyHometown"))
              old.setLocation(session.getAttribute("userName").toString());
        else
            old.setLocation(Location);
        old.setBody(request.getParameter("body").toString());
        old.setTitle(request.getParameter("title").toString());
        old.setTopic(request.getParameter("topic").toString());


        String userName=session.getAttribute("userName").toString();
        Users u=usersFacade.find(usersFacade.getIdByUser(userName));
        /*
        String oldlog=u.getLog();
        if(oldlog != null) {
        String[] str=oldlog.split("\\|");
        if(str.length==11)
        {
            oldlog=oldlog.substring(oldlog.indexOf("|")+1);
            oldlog=oldlog.substring(oldlog.indexOf("|"));
        }}

        java.util.Date utilDate = new java.util.Date();
            java.sql.Date sqlDate = new java.sql.Date(utilDate.getTime());
            if(oldlog != null) {
                u.setLog(oldlog+"|2$"+id+"$"+sqlDate);
            }
            else
                u.setLog("|2$"+id+"$"+sqlDate);
*/
            PrintWriter out = response.getWriter();

        try {
            // TODO output your page here
            out.println("<html>");
            out.println("<head>");
            out.println("<link href=\"design/css/savechanges.css\" type=\"text/css\" rel=\"stylesheet\" />");
            out.println("<title>SaveChanges</title>");  
            out.println("</head>");
            out.println("<body>");
            out.println("<table id=\"success\"><tr>");
            out.println("<td><img src=\"design/Pictures/info.png\" /></td>");
            try {
                newsEntityFacade.edit(old);
                usersFacade.edit(u);
               
                out.println("<td align=\"center\" id=\"rightcell\">Your message has been edited successfully!</td></tr></table>");
            }
            catch(Exception e) {
                out.println("<td align=\"center\" id=\"rightcell\">Your message could not be edited because of problem: " +e.getMessage()+"</td></tr></table>");
            }
             out.println("<a href=\"ListNews\"><img id=\"home\" src=\"design/Pictures/home.png\"></a>");
            out.println("</body>");
            out.println("</html>");
        } finally { 
            out.close();
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
